<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RequiredField ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RequiredField extends AbstractStructArrayBase
{
    /**
     * The Field
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RequiredField[]
     */
    public $Field;
    /**
     * Constructor method for ArrayOfJP_RequiredField
     * @uses ArrayOfJP_RequiredField::setField()
     * @param \StructType\JP_RequiredField[] $field
     */
    public function __construct(array $field = array())
    {
        $this
            ->setField($field);
    }
    /**
     * Get Field value
     * @return \StructType\JP_RequiredField[]|null
     */
    public function getField()
    {
        return $this->Field;
    }
    /**
     * This method is responsible for validating the values passed to the setField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFieldForArrayConstraintsFromSetField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_RequiredFieldFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RequiredFieldFieldItem instanceof \StructType\JP_RequiredField) {
                $invalidValues[] = is_object($arrayOfJP_RequiredFieldFieldItem) ? get_class($arrayOfJP_RequiredFieldFieldItem) : sprintf('%s(%s)', gettype($arrayOfJP_RequiredFieldFieldItem), var_export($arrayOfJP_RequiredFieldFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Field property can only contain items of type \StructType\JP_RequiredField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Field value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RequiredField[] $field
     * @return \ArrayType\ArrayOfJP_RequiredField
     */
    public function setField(array $field = array())
    {
        // validation for constraint: array
        if ('' !== ($fieldArrayErrorMessage = self::validateFieldForArrayConstraintsFromSetField($field))) {
            throw new \InvalidArgumentException($fieldArrayErrorMessage, __LINE__);
        }
        $this->Field = $field;
        return $this;
    }
    /**
     * Add item to Field value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RequiredField $item
     * @return \ArrayType\ArrayOfJP_RequiredField
     */
    public function addToField(\StructType\JP_RequiredField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RequiredField) {
            throw new \InvalidArgumentException(sprintf('The Field property can only contain items of type \StructType\JP_RequiredField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Field[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RequiredField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RequiredField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RequiredField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RequiredField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RequiredField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Field
     */
    public function getAttributeName()
    {
        return 'Field';
    }
}
